# Point Light Walkers (PLW) Documentation

## What it is?
Point Light Walkers (PLW) is a user-friendly toolbox for MATLAB (or GNU/Octave) that aims to aid biological motion research in psychophysics providing:

  - support for read/write access to scientific data format HDF5;
  - various straightforward psychopysics experimental design;
  - 4 dimensional data transformation repreasenting biological motion animation in 3D space;
  - high precision on-the-fly visualization built upon Psychtoolbox (using OpenGL);
  - visual, auditory and tactile simulation with high precision response capturing;
  - semi-automated data cleansing and data analysis (ANOVA, MAVONA, rANOVA and more);

## Usage
1. [Download the `.zip` file](https://github.com/hyiltiz/PLW/archive/master.zip) from this Github page;
1. Install [Psychtoolbox 3.0](http://psychtoolbox.org/download/) if you are using `PLW` with Psychtoolbox;
1. refer to `./lib/RL_PLW` which serves as the API to this library ;
1. use scripts under `./lib/data/` for data analysis;

