function createfigure(X1, Y1, X2, X3, Y2, X4)
  %CREATEFIGURE(X1,Y1,X2,X3,Y2,X4)
  %  X1:  vector of x data
  %  Y1:  vector of y data
  %  X2:  vector of x data
  %  X3:  vector of x data
  %  Y2:  vector of y data
  %  X4:  vector of x data

  %  Auto-generated by MATLAB on 11-Jan-2013 17:07:58

  % Create figure
  figure1 = figure;

  % Create axes
  axes1 = axes('Parent',figure1,'YTickLabel',{'visual','tactile'},...
    'YTick',[0 1],...
    'XGrid','on');
  %% Uncomment the following line to preserve the X-limits of the axes
  % xlim(axes1,[0 700]);
  %% Uncomment the following line to preserve the Y-limits of the axes
  % ylim(axes1,[0 10]);
  hold(axes1,'all');

  % Create plot
  plot(X1,Y1,'Parent',axes1,'Marker','o','LineStyle','none','Color',[1 0 0],...
    'DisplayName','left-tactile');

  % Create plot
  plot(X2,Y1,'Parent',axes1,'Marker','o','LineStyle','none','Color',[0 0 1],...
    'DisplayName','right-tactile');

  % Create plot
  plot(X3,Y2,'Parent',axes1,'Marker','*','LineStyle','none','Color',[0 0 1],...
    'DisplayName','right-visual');

  % Create plot
  plot(X4,Y2,'Parent',axes1,'Marker','*','LineStyle','none','Color',[1 0 0],...
    'DisplayName','left-visual');

  % Create xlabel
  xlabel('Flip/.02ms');

  % Create ylabel
  ylabel('Stimuli type');

  % Create title
  title('Tactile-Visual Stimuli (about 13s)');

  % Create legend
  legend1 = legend(axes1,'show');
  set(legend1,'Orientation','horizontal');

