# 毕业设计方案（概要）

## 实验设计

### 实验目的 

检验社会性特征对生物运动跨通道认知的影响

### 实验方法

  1. 实验前用状态-特质焦虑量表STAI 测量被试的状态焦虑指数，和特质焦虑指数，并选出高分组和低分组参加实验( *问题* :  状态焦虑指数SAI 和 特质焦虑指数TAI 虽然相关——自然情况下S-AI分略低于T-AI分——实验中根据SAI分组选被试还是TAI？)。  

  1. 进行视觉-触觉多通道电脑实验。呈现空间中围绕中心注视点分布的8个PLW，其中半数面向里，半数者向外。各PLW背后呈现处理后( *问题* :通过调节透明度，还是通过栅格化？)的面孔刺激，分为正性或者负性。其所占比例根据实验条件不同而不同（控制），分别为6/2（正性主导）、4/4（相同）、2/6（负性主导）、0/0(无面孔刺激——基线)。给被试脚呈现两对触觉刺激，左脚分别在左脚后侧与左脚前侧。(*问题* : 8个PLW起始步态是否随机？ 若是，触觉刺激对应哪个PLW的步态？) 要求被试判断多数PLW是往里，还是往外，并指出若无法判断则可以不做反应。

  1. 实验后通过人际反应指数量表IRI 测量共情关注EC、观点采择PT等人际反映指数。

### 实验预期

  1. 焦虑高分组和焦虑低分组进行t检验，检验其主导时间结构的区别。
  1. 对焦虑高分组和焦虑低分组分别进行rANOVA，检验EC或PT对其主导时间的结构的影响。

## 实验步骤

### STAI 细节

被试做实验之前，通过Excel做STAI，并表中不提供除了量表本身之外的线索（如编码等）。让高分组或者低分组参与电脑实验。分数在1个标准差之间的被试只提供部分被试费，并不参与电脑实验。

由指导语和二个分量表共40项描述题组成。第1-20项为状态焦虑量表(STAI，Form Y-I，以下简称S-AD。其中半数为描述负性情绪的条目，半数为正性情绪条目。主要用于评定即刻的或最近某一特定时间或情景的恐惧、紧张、忧虑和神经质的体验或感受。可用来评价应激情况下的状态焦虑。第21-40题为特质焦虑量表（STAI，Form Y-l，简称T-AI)，用于评定人们经常的情绪体验。其中有11项为描述负性情绪条目，9项为正性情绪条目。

评定方法：该问卷由自我评定或自我报告来完成。受试者根据指导语逐题圈出答案。可用于个人或集体测试，受试者一般需具有初中文化水平。测查无时间限制，一般10-20分钟可完成整个量表条目的回答。

计分法：STAI每一项进行1-4级评分S-AI：1一完全没有，2一有些，3一中等程度，4一非常明显。T-AI：1一几乎没有，2一有些，3一经常，4一几乎总是如此。由受试者根据自己的体验选圈最合适的分值。凡正性情绪项目均为反序计分。分别计算S-AI和T-AI量表的累加分，最小值20，最大值为80，反映状态或特质焦虑的程度。下表显示各项目所属类别（SAI或TAI）、正序（正数）或逆序（负数）性。

      SAI: [1, -2, 3, 4, -5, 6, 7, -8, 9, -10, -11, 12, 13, 14, -15, -16, 17, 18, -19, -20]
      TAI: [21, 22, -23, -24, 25, -26, -27, 28, 29, -30, 31, 32, -33, -34, 35, -36, 37, 38, -39, 40]

北医大精神卫生研究所与长春第一汽车公司职工医院精神科合作在长春地区和北京分别对正常人群与抑郁症病人进行了STAI中译版的测试。获得了与原作者近似的结果：1.正常人群总样本S-AI评分为39.71±8.89（男，375例），38.97±8.45（女，443例）；T-AI评分为41.11±7.74（男），41.31±7.54（女）。抑郁症组(50例）：S-AI为57.22±10.48，T-AI为46.22±26.22，明显高于正常人群。2.各年龄组与S-Al评分无明显差异；T-AI评分以50-55岁的男性组最高（平均42.8)。3.不同文化组的评分无差异。4.不同职业者中S-AI与T-AI的评分均以女性干部为最低（平均36. 7和39.6)。

分类依据： 根据以上材料，初步筛选掉分数在 [35,45] 区间的被试。

### STAI 状态一特质焦虑问卷

指导语：下面列出的是一些人们常常用来描述他们自己的陈述，请阅读每一个陈述，然后在右边适当的圈上打勾来表示你现在最恰当的感觉，也就是你此时此刻最恰当的感觉。没有对或错的回答，不要对任何一个陈述花太多的时间去考虑，但所给的回答应该是你现在最恰当的感觉。

1一完全没有，2一有些，3一中等程度，4一非常明显

 1. 我感到心情平静
 2. 我感到安全
 3. 我是紧张的
 4. 我感到紧张束缚
 5. 我感到安逸
 6. 我感到烦乱
 7. 我现在正烦恼，感到这种烦恼超过了可能的不幸
 8. 我感到满意
 9. 我感到害怕
 10. 我感到舒适
 11. 我有自信心
 12. 我觉得神经过敏
 13. 我极度紧张不安
 14. 我优柔寡断
 15. 我是轻松的
 16. 我感到心满意足
 17. 我是烦恼的
 18. 我感到慌乱
 19. 我感觉镇定
 20. 我感到愉快

指导语：下面列出的是人们常常用来描述他们自己的一些陈述，请阅读每一个陈述后，然后在右边恰当约圈内打勾，来表示你经常的感觉。没有对或错的回答。不要对任何一个陈述花太多的时间去考虑，但所给均回答应该是你平常所感觉到的。

1一几乎没有，2一有些，3一经常，4一几乎总是如此

 21. 我感到愉快
 22. 感到神经过敏和不安
 23. 我感到自我满足
 24. 我希望能象别人那样高兴
 25. 我感到我象衰竭一样
 26. 我感到很宁静
 27. 我是平静的、冷静的和泰然自若的
 28. 我感到困难一一堆集起来，因此无法克服
 29. 我过分优虑一些事，实际这些事无关紧要
 30. 我是高兴的
 31. 我的思想处于混乱状态
 32. 我缺乏自信心
 33. 我感到安全
 34. 我容易做出决断
 35. 我感到不合适
 36. 我是满足的
 37. 一些不重要的思想总缠绕着我，并打扰我
 38. 我产生的沮丧是如此强烈，以致我不能从思想中排除它们
 39. 我是一个镇定的人
 40. 当我考虑我目前的事情和利益时，我就陷人紧张状态
